//
//  AuthNService.h
//
//  Created by CA Technologies
//  Copyright (c) 2012 CA Technologies. All rights reserved.
//
#import <Foundation/Foundation.h>
#import "AuthNContext.h"

/**
   This class helps clients to communicate with the server using http/https protocol.
 */
@interface AuthNService : NSObject {
    NSString *nwErrMsg;
    NSString *cookieStr;
    AuthNContext *authNContext;
}

@property (retain,nonatomic) NSString *nwErrMsg;
@property (retain,nonatomic) NSString *cookieStr;

@property (retain,nonatomic) AuthNContext *authNContext;

+ (NSString *) escapeUrlString:(NSString *)myStr;
+ (NSString *) unescapeUrlString:(NSString *)myStr;
+ (NSString *) base64encode:(NSData *)plainText;
+ (NSString *) basicAuthStringForUID:(NSString *)uid pw:(NSString *)pw;

- (void) connection:(NSURLConnection *)connection didReceiveResponse:(NSHTTPURLResponse *)response;
- (void) connection:(NSURLConnection *)connection didFailWithError:(NSError *)error;
- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)data;
- (void) connectionDidFinishLoading:(NSURLConnection *)connection;
- (NSURLRequest *) connection:(NSURLConnection *)connection willSendRequest:(NSURLRequest *)request redirectResponse:(NSHTTPURLResponse *)response;

- (AuthNContext *) execute;

@end
