package com.example.smandroidauthn;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.CheckBox;
import android.widget.TextView;

public class ConfView extends Activity {

	protected CheckBox showBizPage;
	protected TextView targetText;
	protected TextView loginIDText;
	protected TextView serverText;
	protected TextView loginText;
	protected TextView logoutText;
	protected TextView sessionText;
	
	public static final String PREFERENCES_NS="com.example.smandroidauthn";
	public static final String TARGET_URL="targetURL";
	public static final String LOGIN_ID="LoginID";
	public static final String SERVER_URL="ServerURL";
	public static final String LOGIN_PATH="LoginPath";
	public static final String LOGOUT_PATH="LogoutPath";
	public static final String SESSION_PATH="SessionPath";
	public static final String SHOW_BIZPAGE="ShowBizPage";
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_conf_view);
		
		showBizPage = (CheckBox) findViewById(R.id.showBizPage);
		targetText = (TextView) findViewById(R.id.targetText);
		loginIDText = (TextView) findViewById(R.id.loginIDText);
		serverText = (TextView) findViewById(R.id.serverText);
		loginText = (TextView) findViewById(R.id.loginText);
		logoutText = (TextView) findViewById(R.id.logoutText);
		sessionText = (TextView) findViewById(R.id.sessionText);
		
		loadConfig();
	}
	
	private void loadConfig(){
		SharedPreferences preferences = getSharedPreferences(PREFERENCES_NS, Context.MODE_PRIVATE);
		targetText.setText(preferences.getString(TARGET_URL,""));
		loginIDText.setText(preferences.getString(LOGIN_ID,""));
		serverText.setText(preferences.getString(SERVER_URL,""));
		loginText.setText(preferences.getString(LOGIN_PATH,""));
		logoutText.setText(preferences.getString(LOGOUT_PATH,""));
		sessionText.setText(preferences.getString(SESSION_PATH,""));
		showBizPage.setChecked(preferences.getBoolean(SHOW_BIZPAGE,true));
	}
	
	private void saveConfig(){

		Editor preferences = getSharedPreferences(PREFERENCES_NS, Context.MODE_PRIVATE).edit();
		preferences.putString(TARGET_URL,targetText.getText().toString());
		preferences.putString(LOGIN_ID, loginIDText.getText().toString());
		String tempServerURL = serverText.getText().toString();
		if(tempServerURL.lastIndexOf("/") != tempServerURL.length() -1){
			tempServerURL = tempServerURL + "/";
		}
		preferences.putString(SERVER_URL, tempServerURL);
		preferences.putString(LOGIN_PATH,loginText.getText().toString());
		preferences.putString(LOGOUT_PATH, logoutText.getText().toString());
		preferences.putString(SESSION_PATH, sessionText.getText().toString());
		preferences.putBoolean(SHOW_BIZPAGE,showBizPage.isChecked());
		preferences.commit();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_conf_view, menu);
		return true;
	}

	public void save(View view){
		saveConfig();
	}
	
	public void clear(View view){
		showBizPage.setChecked(true);
		targetText.setText("");
		loginIDText.setText("");
		serverText.setText("");
		loginText.setText("");
		logoutText.setText("");
		sessionText.setText("");
	}
	
	public void reset(View view){
		showBizPage.setChecked(true);
		targetText.setText("authn:http://www.ca.com");
		loginIDText.setText("jsmith");
		serverText.setText("http://minicookie.forwardinc.mobi/");
		loginText.setText("sma/loginonget.fcc");
		logoutText.setText("sma/logout.fcc");
		sessionText.setText("status.asp");
	}
	
}
